HDU 3586 Information Disturbing 树形DP+二分

Information Disturbing

Problem Description

In the battlefield , an effective way to defeat enemies is to break their communication system.
The information department told you that there are n enemy soldiers and their network which have n-1 communication routes can cover all of their soldiers. Information can exchange between any two soldiers by the communication routes. The number 1 soldier is the total commander and other soldiers who have only one neighbour is the frontline soldier.
Your boss zzn ordered you to cut off some routes to make any frontline soldiers in the network cannot reflect the information they collect from the battlefield to the total commander( number 1 soldier).
There is a kind of device who can choose some routes to cut off . But the cost (w) of any route you choose to cut off can’t be more than the device’s upper limit power. And the sum of the cost can’t be more than the device’s life m.
Now please minimize the upper limit power of your device to finish your task.

Input

The input consists of several test cases. 
The first line of each test case contains 2 integers: n(n<=1000)m(m<=1000000).
Each of the following N-1 lines is of the form:
ai bi wi
It means there’s one route from ai to bi(undirected) and it takes wi cost to cut off the route with the device.
(1<=ai,bi<=n,1<=wi<=1000)
The input ends with n=m=0.

Output

Each case should output one integer, the minimal possible upper limit power of your device to finish your task. 
If there is no way to finish the task, output -1.

Sample Input

5 5
1 3 2
1 4 3
3 5 5
4 2 6
0 0

Sample Output

3

题意:

  给你n点的树,每条边有权值

  你可以任意选边切断,使得最后的所有原图中的叶子节点都不与1相连

  这会花费切断边的权值cost,切断的边中 权值最大边 w

  必须满足的是 cost不超过给定的m,且使得w尽量小

  输出这个最小的w,没有满足条件的 -1

题解:

  我们二分答案

  对于得到limit,我们在树上选边切断的时候 保持被切断的边的权值不超过它就是了,每次DP处理即可

#include <iostream>
#include <cstdio>
#include <cmath>
#include <cstring>
#include<vector>
#include <algorithm>
using namespace std;
const int N = 1e3+20, M = 1e2+10, mod = 1e9+7, inf = 1e9+1000;
typedef long long ll;

struct edge{int to,next,w;}e[N * 4];
int head[N] , t , n , m , cost, dp[N];
void add(int u,int v,int w) {e[t].to=v,e[t].w=w,e[t].next=head[u];head[u]=t++;}
void init() {t=1;memset(head,-1,sizeof(head));}
void dfs(int u,int fa,int limit) {
    int ret = 0, cnt = 0;
    for(int i=head[u];i!=-1;i=e[i].next) {
        int to = e[i].to;
        int value = e[i].w;
        if(to == fa) continue;
        cnt += 1;
        dfs(to,u,limit);
        if(dp[to] == -1) {
            if(value <= limit) ret += value;
            else return ;
        }else {
            if(value <= limit) ret += min(dp[to] , value);
            else ret += dp[to];
        }
    }
    if(cnt)dp[u] = ret;
}
int check(int limit) {
    memset(dp,-1,sizeof(dp));
    dfs(1,-1,limit);
    if(dp[1] == -1) return 0;
    else {
        cost = dp[1];
        return 1;
    }
}
int main()
{
    while(~scanf("%d%d",&n,&m)) {
        if(!n&&!m) break;
        int mx = 0;
        init();
        for(int i=1;i<n;i++) {
            int a,b,c;
            scanf("%d%d%d",&a,&b,&c);
            mx = max(c,mx);
            add(a,b,c);
            add(b,a,c);
        }
        int l = 0, r = mx, ans = -1;
        while(l<=r) {
            int mid = (l+r) / 2;
            cost = 0;
            int OK = check(mid);
            if(OK && cost <= m) {
                r = mid - 1;
                ans = mid;
            }else {
                l = mid + 1;
            }
        }
        if(ans == -1) puts("-1");
        else if(check(ans)&&cost <= m) cout<<ans<<endl;
        else puts("-1");
    }
}
时间: 2024-12-26 00:59:13

HDU 3586 Information Disturbing 树形DP+二分的相关文章

HDU 3586.Information Disturbing 树形dp

Information Disturbing Time Limit: 6000/3000 MS (Java/Others)    Memory Limit: 131072/65536 K (Java/Others)Total Submission(s): 3205    Accepted Submission(s): 1137 Problem Description In the battlefield , an effective way to defeat enemies is to bre

[hdu3586]Information Disturbing树形dp+二分

题意:给出一棵带权无向树,以及给定节点1,总约束为$m$,找出切断与所有叶子节点联系每条边所需要的最小价值约束. 解题关键:二分答案,转化为判定性问题,然后用树形dp验证答案即可. dp数组需要开到ll,如果用设inf的解法. 1 #include<bits/stdc++.h> 2 using namespace std; 3 typedef long long ll; 4 const int maxn=1e6+7; 5 const int inf=0x3f3f3f3f; 6 struct e

HDU3585 Information Disturbing 树形dp+二分

http://acm.split.hdu.edu.cn/showproblem.php?pid=3586 题意 : 给定一个带权无向树,要切断所有叶子节点和1号节点(总根)的联系,每次切断边的费用不能超过上限limit,问在保证总费用<=m下的最小的limit. 显然最小的总费用和最小的limit不能同时维护,那么只能在dfs中维护一个然后另一个用特殊的(朗诵)技巧解决-- emmmmmmmmm--说白了就是二分求最小的limit,然后就没有下面了. 算是普通难度,只要知道二分就很好写,虽然我开

HDU 3586 Information Disturbing(二分+树形dp)

http://acm.split.hdu.edu.cn/showproblem.php?pid=3586 题意: 给定一个带权无向树,要切断所有叶子节点和1号节点(总根)的联系,每次切断边的费用不能超过上限limit,问在保证总费用<=m下的最小的limit. 思路: 对于上限limit我们可以二分查找.然后就是树形dp,看代码就可以理解的. 1 #include<iostream> 2 #include<algorithm> 3 #include<cstring>

hdu 3586 Information Disturbing (树形dp)

Information Disturbing Time Limit: 6000/3000 MS (Java/Others)    Memory Limit: 131072/65536 K (Java/Others) Total Submission(s): 1722    Accepted Submission(s): 641 Problem Description In the battlefield , an effective way to defeat enemies is to bre

HDU 3586 Information Disturbing

二分+树形DP验证. 答案是通过二分查找得到的,对于每一次二分到的值,进行验证,是否可行. 可以用树形DP来求解所有叶子节点不能向根节点传送消息的最小费用,dp[i] 表示 节点i 的子树的叶子结点都不能向i传送消息的最小费用,这样很容易递推. #include<cstdio> #include<cstring> #include<cmath> #include<ctime> #include<map> #include<vector>

HDU 3586 Information Disturbing (二分+树形dp)

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=3586 给定n个敌方据点,1为司令部,其他点各有一条边相连构成一棵树,每条边都有一个权值cost表示破坏这条边的费用,叶子节点为前线.现要切断前线和司令部的联系,每次切断边的费用不能超过上限limit,问切断所有前线与司令部联系所花费的总费用少于m时的最小limit.1<=n<=1000,1<=m<=10^6 dp[i]表示i节点为root的这个子树所破坏的最少费用,if(cost[i]

HDU 3586 Information Disturbing (树形DP,二分)

题意: 给定一个敌人的通信系统,是一棵树形,每个节点是一个敌人士兵,根节点是commander,叶子是前线,我们的目的是使得敌人的前线无法将消息传到commander,需要切断一些边,切断每条边需要一定的power,而我们有一台具有m点power的机器,问在使用此机器切断敌人通信系统的情况下,使得所切断边的最大边权达到最小是多少?(m<=100w,n<=1000) 思路: 其实就是要求所切断的边的最小瓶颈边.由于m比较大,不好枚举或者DP.但是他们具有线性的关系,就是瓶颈边越大,肯定越容易有解

[HDU3586]Information Disturbing(DP + 二分)

传送门 二分答案,再 DP,看看最终结果是否小于 m ——代码 1 #include <cstdio> 2 #include <cstring> 3 #include <iostream> 4 #define N 1001 5 #define max(x, y) ((x) > (y) ? (x) : (y)) 6 7 int n, m, cnt, ans; 8 int a[N], sum[N], head[N], to[N << 1], val[N &